const express = require('express');
const app = express();
const arg = process.argv;
const fs = require('fs');
const path = require('path');
const https = require('https');
const multer = require('multer');
const port = arg[3]&&arg[3]>0?arg[3]:443;
app.use(express.json()); //  application/json
app.disable('x-powered-by');//去除x-powered-by响应字段
// application/x-www-form-urlencoded
app.use(express.urlencoded({ extended: true })); 
// 根据项目的路径导入生成的证书文件
const key = fs.readFileSync(path.join(__dirname,'./key/private.key'))
const cert = fs.readFileSync(path.join(__dirname,'./key/cert.pem'))
//.any()上传任何文件 .array("files")上传"files"文件
app.use(multer({ dest: "/" }).any());
const static = require('../plug-in/static');
const api = require('./api/api');
const h5 = path.join(__dirname,'./h5')
// 配置静态资源路径
const route = ['','favicon.ico','assets','static','index','index.htm','index.html'];
app.all('*', (req, res) => { 
    const {originalUrl} = req;
    let urls = originalUrl.split("?");
    const url = urls[0].split("/");
    if(url[1]==''||url[1]=='index'||url[1]=='index.htm'){
        urls[0] = '/index.html'
    }
    if(route.indexOf(url[1])>-1){
        // 静态资源
        static(h5+urls[0].replaceAll('/','\\'),res)
    }else{
        // api路径
        api(req, res)
    }
})
https.createServer({key,cert}, app).listen(port,() => {
    console.log(`HTTPS Server is running on: https://127.0.0.1:${port}`)
    const c = require('child_process');
    c.exec('start https://127.0.0.1:'+port);
});
