function check(port) {
    return new Promise((resolve) => {
        const net = require('net');
        // 创建服务并监听该端口
        var server = net.createServer().listen(port);
        server.on('listening', () => {
            // 执行这块代码说明端口未被占用
            server.close();
            resolve(true);
        })
        server.on('error', (err)=> {
            if (err.code === 'EADDRINUSE') { // 端口已经被使用
                console.log('Port has been occupied!');
                resolve(false)
            }else{
                console.log('An unknown error!');
            }
            server.close();
        })
    })
}
module.exports = {check};
